-----------------------------------------------------
---- Raeli's Spell Announcer Death Knight Module ----
-----------------------------------------------------
local RSA = LibStub("AceAddon-3.0"):GetAddon("RSA")
local L = LibStub("AceLocale-3.0"):GetLocale("RSA")
local RSA_DeathKnight = RSA:NewModule("DeathKnight")

-----------------------
---- Ace functions ----
-----------------------
function RSA_DeathKnight:OnInitialize()
	
	if RSA.db.profile.General.Class == "DEATHKNIGHT" then
	RSA_DeathKnight:SetEnabledState(true)
	else
	RSA_DeathKnight:SetEnabledState(false)
	end
end

function RSA_DeathKnight:OnEnable()

-----------------------------
---- Combat Log Checking ----
-----------------------------
local pName = UnitName("player")
local petName = UnitName("pet")
local function DeathKnight_Spells(_, _, _, event, _, source, _, _, dest, _, spellID, spellName, _, missType)
	if source == pName or source == petName then
		if (event == "SPELL_CAST_SUCCESS" and RSA.db.profile.Modules.Reminders_Loaded == true) then -- Reminder Refreshed
			local ReminderSpell = RSA.db.profile.DeathKnight.Reminders.SpellName
			if spellName == ReminderSpell and (dest == pName or dest == nil) then
				RSA_Reminder:SetScript("OnUpdate", nil)				
				if RSA.db.profile.Reminders.RemindChannels.Chat == true then
					RSA_Print_Self(ReminderSpell .. " Refreshed!")
				end
				if RSA.db.profile.Reminders.RemindChannels.RaidWarn == true then
					RSA_Print_Self_RW(ReminderSpell .. " Refreshed!")
				end
			end			
		end -- BUFF REMINDER


		if event == "SPELL_AURA_APPLIED" then		
			if spellID == 56222 then -- DARK COMMAND
				RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest,}
				if RSA.db.profile.DeathKnight.Spells.DarkCommand.Messages.Start ~= "" then
					if RSA.db.profile.DeathKnight.Spells.DarkCommand.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							RSA_Print_Self_RW(string.gsub(RSA.db.profile.DeathKnight.Spells.DarkCommand.Messages.Start, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							RSA_Print_Self(string.gsub(RSA.db.profile.DeathKnight.Spells.DarkCommand.Messages.Start, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.DeathKnight.Spells.DarkCommand.Whisper == true then
						RSA_Print_Whisper(string.gsub(RSA.db.profile.DeathKnight.Spells.DarkCommand.Messages.Start, ".%a+.", RSA_String_Replace), dest)
					end
					if RSA.db.profile.DeathKnight.Spells.DarkCommand.CustomChannel.Enabled == true then
						RSA_Print_Channel(string.gsub(RSA.db.profile.DeathKnight.Spells.DarkCommand.Messages.Start, ".%a+.", RSA_String_Replace), RSA.db.profile.DeathKnight.Spells.DarkCommand.CustomChannel.Channel)
					end
					if RSA.db.profile.DeathKnight.Spells.DarkCommand.Smart.Say == true then
						RSA_Print_Say(string.gsub(RSA.db.profile.DeathKnight.Spells.DarkCommand.Messages.Start, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.DeathKnight.Spells.DarkCommand.Smart.RaidParty == true then
							RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.DeathKnight.Spells.DarkCommand.Messages.Start, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.DeathKnight.Spells.DarkCommand.Party == true then
							RSA_Print_Party(string.gsub(RSA.db.profile.DeathKnight.Spells.DarkCommand.Messages.Start, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.DeathKnight.Spells.DarkCommand.Raid == true then
							RSA_Print_Raid(string.gsub(RSA.db.profile.DeathKnight.Spells.DarkCommand.Messages.Start, ".%a+.", RSA_String_Replace))
						end
					end

				end
			end -- DARK COMMAND
			if spellID == 49560 then -- DEATH GRIP
				RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest,}
				if RSA.db.profile.DeathKnight.Spells.DeathGrip.Messages.Start ~= "" then
					if RSA.db.profile.DeathKnight.Spells.DeathGrip.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							RSA_Print_Self_RW(string.gsub(RSA.db.profile.DeathKnight.Spells.DeathGrip.Messages.Start, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							RSA_Print_Self(string.gsub(RSA.db.profile.DeathKnight.Spells.DeathGrip.Messages.Start, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.DeathKnight.Spells.DeathGrip.Whisper == true then
						RSA_Print_Whisper(string.gsub(RSA.db.profile.DeathKnight.Spells.DeathGrip.Messages.Start, ".%a+.", RSA_String_Replace), dest)
					end
					if RSA.db.profile.DeathKnight.Spells.DeathGrip.CustomChannel.Enabled == true then
						RSA_Print_Channel(string.gsub(RSA.db.profile.DeathKnight.Spells.DeathGrip.Messages.Start, ".%a+.", RSA_String_Replace), RSA.db.profile.DeathKnight.Spells.DeathGrip.CustomChannel.Channel)
					end
					if RSA.db.profile.DeathKnight.Spells.DeathGrip.Smart.Say == true then
						RSA_Print_Say(string.gsub(RSA.db.profile.DeathKnight.Spells.DeathGrip.Messages.Start, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.DeathKnight.Spells.DeathGrip.Smart.RaidParty == true then
							RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.DeathKnight.Spells.DeathGrip.Messages.Start, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.DeathKnight.Spells.DeathGrip.Party == true then
							RSA_Print_Party(string.gsub(RSA.db.profile.DeathKnight.Spells.DeathGrip.Messages.Start, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.DeathKnight.Spells.DeathGrip.Raid == true then
							RSA_Print_Raid(string.gsub(RSA.db.profile.DeathKnight.Spells.DeathGrip.Messages.Start, ".%a+.", RSA_String_Replace))
						end
					end

				end
			end -- DEATH GRIP
			
		end -- IF EVENT IS SPELL_AURA_APPLIED
		
		
		if event == "SPELL_CAST_SUCCESS" then
			if spellID == 48792 then -- ICEBOUND FORTITUDE
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest,}
				if RSA.db.profile.DeathKnight.Spells.IceboundFortitude.Messages.Start ~= "" then
					if RSA.db.profile.DeathKnight.Spells.IceboundFortitude.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							RSA_Print_Self_RW(string.gsub(RSA.db.profile.DeathKnight.Spells.IceboundFortitude.Messages.Start, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							RSA_Print_Self(string.gsub(RSA.db.profile.DeathKnight.Spells.IceboundFortitude.Messages.Start, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.DeathKnight.Spells.IceboundFortitude.Whisper == true then
						RSA_Print_Whisper(string.gsub(RSA.db.profile.DeathKnight.Spells.IceboundFortitude.Messages.Start, ".%a+.", RSA_String_Replace), dest)
					end
					if RSA.db.profile.DeathKnight.Spells.IceboundFortitude.CustomChannel.Enabled == true then
						RSA_Print_Channel(string.gsub(RSA.db.profile.DeathKnight.Spells.IceboundFortitude.Messages.Start, ".%a+.", RSA_String_Replace), RSA.db.profile.DeathKnight.Spells.IceboundFortitude.CustomChannel.Channel)
					end
					if RSA.db.profile.DeathKnight.Spells.IceboundFortitude.Smart.Say == true then
						RSA_Print_Say(string.gsub(RSA.db.profile.DeathKnight.Spells.IceboundFortitude.Messages.Start, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.DeathKnight.Spells.IceboundFortitude.Smart.RaidParty == true then
							RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.DeathKnight.Spells.IceboundFortitude.Messages.Start, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.DeathKnight.Spells.IceboundFortitude.Party == true then
							RSA_Print_Party(string.gsub(RSA.db.profile.DeathKnight.Spells.IceboundFortitude.Messages.Start, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.DeathKnight.Spells.IceboundFortitude.Raid == true then
							RSA_Print_Raid(string.gsub(RSA.db.profile.DeathKnight.Spells.IceboundFortitude.Messages.Start, ".%a+.", RSA_String_Replace))
						end
					end
				end
			end -- ICEBOUND FORTITUDE		
			if spellID == 55233 then -- VAMPIRIC BLOOD
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest,}
				if RSA.db.profile.DeathKnight.Spells.VampiricBlood.Messages.Start ~= "" then
					if RSA.db.profile.DeathKnight.Spells.VampiricBlood.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							RSA_Print_Self_RW(string.gsub(RSA.db.profile.DeathKnight.Spells.VampiricBlood.Messages.Start, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							RSA_Print_Self(string.gsub(RSA.db.profile.DeathKnight.Spells.VampiricBlood.Messages.Start, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.DeathKnight.Spells.VampiricBlood.Whisper == true then
						RSA_Print_Whisper(string.gsub(RSA.db.profile.DeathKnight.Spells.VampiricBlood.Messages.Start, ".%a+.", RSA_String_Replace), dest)
					end
					if RSA.db.profile.DeathKnight.Spells.VampiricBlood.CustomChannel.Enabled == true then
						RSA_Print_Channel(string.gsub(RSA.db.profile.DeathKnight.Spells.VampiricBlood.Messages.Start, ".%a+.", RSA_String_Replace), RSA.db.profile.DeathKnight.Spells.VampiricBlood.CustomChannel.Channel)
					end
					if RSA.db.profile.DeathKnight.Spells.VampiricBlood.Smart.Say == true then
						RSA_Print_Say(string.gsub(RSA.db.profile.DeathKnight.Spells.VampiricBlood.Messages.Start, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.DeathKnight.Spells.VampiricBlood.Smart.RaidParty == true then
							RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.DeathKnight.Spells.VampiricBlood.Messages.Start, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.DeathKnight.Spells.VampiricBlood.Party == true then
							RSA_Print_Party(string.gsub(RSA.db.profile.DeathKnight.Spells.VampiricBlood.Messages.Start, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.DeathKnight.Spells.VampiricBlood.Raid == true then
							RSA_Print_Raid(string.gsub(RSA.db.profile.DeathKnight.Spells.VampiricBlood.Messages.Start, ".%a+.", RSA_String_Replace))
						end
					end
				end
			end -- VAMPIRIC BLOOD				
			if spellID == 49222 then -- BONE SHIELD
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest,}
				if RSA.db.profile.DeathKnight.Spells.BoneShield.Messages.Start ~= "" then
					if RSA.db.profile.DeathKnight.Spells.BoneShield.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							RSA_Print_Self_RW(string.gsub(RSA.db.profile.DeathKnight.Spells.BoneShield.Messages.Start, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							RSA_Print_Self(string.gsub(RSA.db.profile.DeathKnight.Spells.BoneShield.Messages.Start, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.DeathKnight.Spells.BoneShield.Whisper == true then
						RSA_Print_Whisper(string.gsub(RSA.db.profile.DeathKnight.Spells.BoneShield.Messages.Start, ".%a+.", RSA_String_Replace), dest)
					end
					if RSA.db.profile.DeathKnight.Spells.BoneShield.CustomChannel.Enabled == true then
						RSA_Print_Channel(string.gsub(RSA.db.profile.DeathKnight.Spells.BoneShield.Messages.Start, ".%a+.", RSA_String_Replace), RSA.db.profile.DeathKnight.Spells.BoneShield.CustomChannel.Channel)
					end
					if RSA.db.profile.DeathKnight.Spells.BoneShield.Smart.Say == true then
						RSA_Print_Say(string.gsub(RSA.db.profile.DeathKnight.Spells.BoneShield.Messages.Start, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.DeathKnight.Spells.BoneShield.Smart.RaidParty == true then
							RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.DeathKnight.Spells.BoneShield.Messages.Start, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.DeathKnight.Spells.BoneShield.Party == true then
							RSA_Print_Party(string.gsub(RSA.db.profile.DeathKnight.Spells.BoneShield.Messages.Start, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.DeathKnight.Spells.BoneShield.Raid == true then
							RSA_Print_Raid(string.gsub(RSA.db.profile.DeathKnight.Spells.BoneShield.Messages.Start, ".%a+.", RSA_String_Replace))
						end
					end
				end
			end -- BONE SHIELD	
			if spellID == 48707 then -- ANTI MAGIC SHELL
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest,}
				if RSA.db.profile.DeathKnight.Spells.AMS.Messages.Start ~= "" then
					if RSA.db.profile.DeathKnight.Spells.AMS.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							RSA_Print_Self_RW(string.gsub(RSA.db.profile.DeathKnight.Spells.AMS.Messages.Start, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							RSA_Print_Self(string.gsub(RSA.db.profile.DeathKnight.Spells.AMS.Messages.Start, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.DeathKnight.Spells.AMS.Whisper == true then
						RSA_Print_Whisper(string.gsub(RSA.db.profile.DeathKnight.Spells.AMS.Messages.Start, ".%a+.", RSA_String_Replace), dest)
					end
					if RSA.db.profile.DeathKnight.Spells.AMS.CustomChannel.Enabled == true then
						RSA_Print_Channel(string.gsub(RSA.db.profile.DeathKnight.Spells.AMS.Messages.Start, ".%a+.", RSA_String_Replace), RSA.db.profile.DeathKnight.Spells.AMS.CustomChannel.Channel)
					end
					if RSA.db.profile.DeathKnight.Spells.AMS.Smart.Say == true then
						RSA_Print_Say(string.gsub(RSA.db.profile.DeathKnight.Spells.AMS.Messages.Start, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.DeathKnight.Spells.AMS.Smart.RaidParty == true then
							RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.DeathKnight.Spells.AMS.Messages.Start, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.DeathKnight.Spells.AMS.Party == true then
							RSA_Print_Party(string.gsub(RSA.db.profile.DeathKnight.Spells.AMS.Messages.Start, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.DeathKnight.Spells.AMS.Raid == true then
							RSA_Print_Raid(string.gsub(RSA.db.profile.DeathKnight.Spells.AMS.Messages.Start, ".%a+.", RSA_String_Replace))
						end
					end
				end
			end -- ANTI MAGIC SHELL
			if spellID == 42650 then -- ARMY OF THE DEAD
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest,}
				if RSA.db.profile.DeathKnight.Spells.Army.Messages.Start ~= "" then
					if RSA.db.profile.DeathKnight.Spells.Army.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							RSA_Print_Self_RW(string.gsub(RSA.db.profile.DeathKnight.Spells.Army.Messages.Start, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							RSA_Print_Self(string.gsub(RSA.db.profile.DeathKnight.Spells.Army.Messages.Start, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.DeathKnight.Spells.Army.Whisper == true then
						RSA_Print_Whisper(string.gsub(RSA.db.profile.DeathKnight.Spells.Army.Messages.Start, ".%a+.", RSA_String_Replace), dest)
					end
					if RSA.db.profile.DeathKnight.Spells.Army.CustomChannel.Enabled == true then
						RSA_Print_Channel(string.gsub(RSA.db.profile.DeathKnight.Spells.Army.Messages.Start, ".%a+.", RSA_String_Replace), RSA.db.profile.DeathKnight.Spells.Army.CustomChannel.Channel)
					end
					if RSA.db.profile.DeathKnight.Spells.Army.Smart.Say == true then
						RSA_Print_Say(string.gsub(RSA.db.profile.DeathKnight.Spells.Army.Messages.Start, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.DeathKnight.Spells.Army.Smart.RaidParty == true then
							RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.DeathKnight.Spells.Army.Messages.Start, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.DeathKnight.Spells.Army.Party == true then
							RSA_Print_Party(string.gsub(RSA.db.profile.DeathKnight.Spells.Army.Messages.Start, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.DeathKnight.Spells.Army.Raid == true then
							RSA_Print_Raid(string.gsub(RSA.db.profile.DeathKnight.Spells.Army.Messages.Start, ".%a+.", RSA_String_Replace))
						end
					end
				end
			end -- ARMY OF THE DEAD			

		end -- IF EVENT IS SPELL_CAST_SUCCESS

		
		if event == "SPELL_INTERRUPT" then
			if spellID == 47476 then -- STRANGULATE
				spellinfo = GetSpellInfo(spellID)
				spelllinkinfo = GetSpellLink(spellID)
				extraspellinfo = GetSpellInfo(missType)
				extraspellinfolink = GetSpellLink(missType)
				RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest, ["[TARCAST]"] = extraspellinfo, ["[TARLINK]"] = extraspellinfolink,}
				if RSA.db.profile.DeathKnight.Spells.Strangulate.Messages.Start ~= "" then
					if RSA.db.profile.DeathKnight.Spells.Strangulate.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							RSA_Print_Self_RW(string.gsub(RSA.db.profile.DeathKnight.Spells.Strangulate.Messages.Start, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							RSA_Print_Self(string.gsub(RSA.db.profile.DeathKnight.Spells.Strangulate.Messages.Start, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.DeathKnight.Spells.Strangulate.Whisper == true then
						RSA_Print_Whisper(string.gsub(RSA.db.profile.DeathKnight.Spells.Strangulate.Messages.Start, ".%a+.", RSA_String_Replace), dest)
					end
					if RSA.db.profile.DeathKnight.Spells.Strangulate.CustomChannel.Enabled == true then
						RSA_Print_Channel(string.gsub(RSA.db.profile.DeathKnight.Spells.Strangulate.Messages.Start, ".%a+.", RSA_String_Replace), RSA.db.profile.DeathKnight.Spells.Strangulate.CustomChannel.Channel)
					end
					if RSA.db.profile.DeathKnight.Spells.Strangulate.Smart.Say == true then
						RSA_Print_Say(string.gsub(RSA.db.profile.DeathKnight.Spells.Strangulate.Messages.Start, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.DeathKnight.Spells.Strangulate.Smart.RaidParty == true then
							RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.DeathKnight.Spells.Strangulate.Messages.Start, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.DeathKnight.Spells.Strangulate.Party == true then
							RSA_Print_Party(string.gsub(RSA.db.profile.DeathKnight.Spells.Strangulate.Messages.Start, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.DeathKnight.Spells.Strangulate.Raid == true then
							RSA_Print_Raid(string.gsub(RSA.db.profile.DeathKnight.Spells.Strangulate.Messages.Start, ".%a+.", RSA_String_Replace))
						end
					end
				end
			end -- STRANGULATE
			if spellID == 47528 then -- MIND FREEZE
				spellinfo = GetSpellInfo(spellID)
				spelllinkinfo = GetSpellLink(spellID)
				extraspellinfo = GetSpellInfo(missType)
				extraspellinfolink = GetSpellLink(missType)
				RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest, ["[TARCAST]"] = extraspellinfo, ["[TARLINK]"] = extraspellinfolink,}
				if RSA.db.profile.DeathKnight.Spells.MindFreeze.Messages.Start ~= "" then
					if RSA.db.profile.DeathKnight.Spells.MindFreeze.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							RSA_Print_Self_RW(string.gsub(RSA.db.profile.DeathKnight.Spells.MindFreeze.Messages.Start, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							RSA_Print_Self(string.gsub(RSA.db.profile.DeathKnight.Spells.MindFreeze.Messages.Start, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.DeathKnight.Spells.MindFreeze.Whisper == true then
						RSA_Print_Whisper(string.gsub(RSA.db.profile.DeathKnight.Spells.MindFreeze.Messages.Start, ".%a+.", RSA_String_Replace), dest)
					end
					if RSA.db.profile.DeathKnight.Spells.MindFreeze.CustomChannel.Enabled == true then
						RSA_Print_Channel(string.gsub(RSA.db.profile.DeathKnight.Spells.MindFreeze.Messages.Start, ".%a+.", RSA_String_Replace), RSA.db.profile.DeathKnight.Spells.MindFreeze.CustomChannel.Channel)
					end
					if RSA.db.profile.DeathKnight.Spells.MindFreeze.Smart.Say == true then
						RSA_Print_Say(string.gsub(RSA.db.profile.DeathKnight.Spells.MindFreeze.Messages.Start, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.DeathKnight.Spells.MindFreeze.Smart.RaidParty == true then
							RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.DeathKnight.Spells.MindFreeze.Messages.Start, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.DeathKnight.Spells.MindFreeze.Party == true then
							RSA_Print_Party(string.gsub(RSA.db.profile.DeathKnight.Spells.MindFreeze.Messages.Start, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.DeathKnight.Spells.MindFreeze.Raid == true then
							RSA_Print_Raid(string.gsub(RSA.db.profile.DeathKnight.Spells.MindFreeze.Messages.Start, ".%a+.", RSA_String_Replace))
						end
					end
				end
			end -- MIND FREEZE

		end -- IF EVENT IS SPELL_INTERRUPT
		
		
		if event == "SPELL_AURA_REMOVED" then
			if spellID == 48792 then -- ICEBOUND FORTITUDE
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest,}
				if RSA.db.profile.DeathKnight.Spells.IceboundFortitude.Messages.End ~= "" then
					if RSA.db.profile.DeathKnight.Spells.IceboundFortitude.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							RSA_Print_Self_RW(string.gsub(RSA.db.profile.DeathKnight.Spells.IceboundFortitude.Messages.End, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							RSA_Print_Self(string.gsub(RSA.db.profile.DeathKnight.Spells.IceboundFortitude.Messages.End, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.DeathKnight.Spells.IceboundFortitude.Whisper == true then
						RSA_Print_Whisper(string.gsub(RSA.db.profile.DeathKnight.Spells.IceboundFortitude.Messages.End, ".%a+.", RSA_String_Replace), dest)
					end
					if RSA.db.profile.DeathKnight.Spells.IceboundFortitude.CustomChannel.Enabled == true then
						RSA_Print_Channel(string.gsub(RSA.db.profile.DeathKnight.Spells.IceboundFortitude.Messages.End, ".%a+.", RSA_String_Replace), RSA.db.profile.DeathKnight.Spells.IceboundFortitude.CustomChannel.Channel)
					end
					if RSA.db.profile.DeathKnight.Spells.IceboundFortitude.Smart.Say == true then
						RSA_Print_Say(string.gsub(RSA.db.profile.DeathKnight.Spells.IceboundFortitude.Messages.End, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.DeathKnight.Spells.IceboundFortitude.Smart.RaidParty == true then
							RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.DeathKnight.Spells.IceboundFortitude.Messages.End, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.DeathKnight.Spells.IceboundFortitude.Party == true then
							RSA_Print_Party(string.gsub(RSA.db.profile.DeathKnight.Spells.IceboundFortitude.Messages.End, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.DeathKnight.Spells.IceboundFortitude.Raid == true then
							RSA_Print_Raid(string.gsub(RSA.db.profile.DeathKnight.Spells.IceboundFortitude.Messages.End, ".%a+.", RSA_String_Replace))
						end
					end
				end
			end -- ICEBOUND FORTITUDE
			if spellID == 55233 then -- VAMPIRIC BLOOD
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest,}
				if RSA.db.profile.DeathKnight.Spells.VampiricBlood.Messages.End ~= "" then
					if RSA.db.profile.DeathKnight.Spells.VampiricBlood.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							RSA_Print_Self_RW(string.gsub(RSA.db.profile.DeathKnight.Spells.VampiricBlood.Messages.End, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							RSA_Print_Self(string.gsub(RSA.db.profile.DeathKnight.Spells.VampiricBlood.Messages.End, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.DeathKnight.Spells.VampiricBlood.Whisper == true then
						RSA_Print_Whisper(string.gsub(RSA.db.profile.DeathKnight.Spells.VampiricBlood.Messages.End, ".%a+.", RSA_String_Replace), dest)
					end
					if RSA.db.profile.DeathKnight.Spells.VampiricBlood.CustomChannel.Enabled == true then
						RSA_Print_Channel(string.gsub(RSA.db.profile.DeathKnight.Spells.VampiricBlood.Messages.End, ".%a+.", RSA_String_Replace), RSA.db.profile.DeathKnight.Spells.VampiricBlood.CustomChannel.Channel)
					end
					if RSA.db.profile.DeathKnight.Spells.VampiricBlood.Smart.Say == true then
						RSA_Print_Say(string.gsub(RSA.db.profile.DeathKnight.Spells.VampiricBlood.Messages.End, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.DeathKnight.Spells.VampiricBlood.Smart.RaidParty == true then
							RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.DeathKnight.Spells.VampiricBlood.Messages.End, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.DeathKnight.Spells.VampiricBlood.Party == true then
							RSA_Print_Party(string.gsub(RSA.db.profile.DeathKnight.Spells.VampiricBlood.Messages.End, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.DeathKnight.Spells.VampiricBlood.Raid == true then
							RSA_Print_Raid(string.gsub(RSA.db.profile.DeathKnight.Spells.VampiricBlood.Messages.End, ".%a+.", RSA_String_Replace))
						end
					end
				end
			end -- VAMPIRIC BLOOD				
			if spellID == 49222 then -- BONE SHIELD
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest,}
				if RSA.db.profile.DeathKnight.Spells.BoneShield.Messages.End ~= "" then
					if RSA.db.profile.DeathKnight.Spells.BoneShield.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							RSA_Print_Self_RW(string.gsub(RSA.db.profile.DeathKnight.Spells.BoneShield.Messages.End, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							RSA_Print_Self(string.gsub(RSA.db.profile.DeathKnight.Spells.BoneShield.Messages.End, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.DeathKnight.Spells.BoneShield.Whisper == true then
						RSA_Print_Whisper(string.gsub(RSA.db.profile.DeathKnight.Spells.BoneShield.Messages.End, ".%a+.", RSA_String_Replace), dest)
					end
					if RSA.db.profile.DeathKnight.Spells.BoneShield.CustomChannel.Enabled == true then
						RSA_Print_Channel(string.gsub(RSA.db.profile.DeathKnight.Spells.BoneShield.Messages.End, ".%a+.", RSA_String_Replace), RSA.db.profile.DeathKnight.Spells.BoneShield.CustomChannel.Channel)
					end
					if RSA.db.profile.DeathKnight.Spells.BoneShield.Smart.Say == true then
						RSA_Print_Say(string.gsub(RSA.db.profile.DeathKnight.Spells.BoneShield.Messages.End, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.DeathKnight.Spells.BoneShield.Smart.RaidParty == true then
							RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.DeathKnight.Spells.BoneShield.Messages.End, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.DeathKnight.Spells.BoneShield.Party == true then
							RSA_Print_Party(string.gsub(RSA.db.profile.DeathKnight.Spells.BoneShield.Messages.End, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.DeathKnight.Spells.BoneShield.Raid == true then
							RSA_Print_Raid(string.gsub(RSA.db.profile.DeathKnight.Spells.BoneShield.Messages.End, ".%a+.", RSA_String_Replace))
						end
					end
				end
			end -- BONE SHIELD	
			if spellID == 48707 then -- ANTI MAGIC SHELL
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest,}
				if RSA.db.profile.DeathKnight.Spells.AMS.Messages.End ~= "" then
					if RSA.db.profile.DeathKnight.Spells.AMS.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							RSA_Print_Self_RW(string.gsub(RSA.db.profile.DeathKnight.Spells.AMS.Messages.End, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							RSA_Print_Self(string.gsub(RSA.db.profile.DeathKnight.Spells.AMS.Messages.End, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.DeathKnight.Spells.AMS.Whisper == true then
						RSA_Print_Whisper(string.gsub(RSA.db.profile.DeathKnight.Spells.AMS.Messages.End, ".%a+.", RSA_String_Replace), dest)
					end
					if RSA.db.profile.DeathKnight.Spells.AMS.CustomChannel.Enabled == true then
						RSA_Print_Channel(string.gsub(RSA.db.profile.DeathKnight.Spells.AMS.Messages.End, ".%a+.", RSA_String_Replace), RSA.db.profile.DeathKnight.Spells.AMS.CustomChannel.Channel)
					end
					if RSA.db.profile.DeathKnight.Spells.AMS.Smart.Say == true then
						RSA_Print_Say(string.gsub(RSA.db.profile.DeathKnight.Spells.AMS.Messages.End, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.DeathKnight.Spells.AMS.Smart.RaidParty == true then
							RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.DeathKnight.Spells.AMS.Messages.End, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.DeathKnight.Spells.AMS.Party == true then
							RSA_Print_Party(string.gsub(RSA.db.profile.DeathKnight.Spells.AMS.Messages.End, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.DeathKnight.Spells.AMS.Raid == true then
							RSA_Print_Raid(string.gsub(RSA.db.profile.DeathKnight.Spells.AMS.Messages.End, ".%a+.", RSA_String_Replace))
						end
					end
				end
			end -- ANTI MAGIC SHELL				

		end -- IF EVENT IS SPELL_AURA_REMOVED
		
		
		if event == "SPELL_MISSED" and missType ~= "IMMUNE" then
			if spellID == 56222 then -- DARK COMMAND
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				if missType == "MISS" then
					missinfo = "Missed"
				elseif missType ~= "MISS" then
					missinfo = "Resisted"
				end
				RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest, ["[MISSTYPE]"] = missinfo,}
				if RSA.db.profile.DeathKnight.Spells.DarkCommand.Messages.End ~= "" then
					if RSA.db.profile.DeathKnight.Spells.DarkCommand.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							RSA_Print_Self_RW(string.gsub(RSA.db.profile.DeathKnight.Spells.DarkCommand.Messages.End, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							RSA_Print_Self(string.gsub(RSA.db.profile.DeathKnight.Spells.DarkCommand.Messages.End, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.DeathKnight.Spells.DarkCommand.Whisper == true then
						RSA_Print_Whisper(string.gsub(RSA.db.profile.DeathKnight.Spells.DarkCommand.Messages.End, ".%a+.", RSA_String_Replace), dest)
					end
					if RSA.db.profile.DeathKnight.Spells.DarkCommand.CustomChannel.Enabled == true then
						RSA_Print_Channel(string.gsub(RSA.db.profile.DeathKnight.Spells.DarkCommand.Messages.End, ".%a+.", RSA_String_Replace), RSA.db.profile.DeathKnight.Spells.DarkCommand.CustomChannel.Channel)
					end
					if RSA.db.profile.DeathKnight.Spells.DarkCommand.Smart.Say == true then
						RSA_Print_Say(string.gsub(RSA.db.profile.DeathKnight.Spells.DarkCommand.Messages.End, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.DeathKnight.Spells.DarkCommand.Smart.RaidParty == true then
							RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.DeathKnight.Spells.DarkCommand.Messages.End, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.DeathKnight.Spells.DarkCommand.Party == true then
							RSA_Print_Party(string.gsub(RSA.db.profile.DeathKnight.Spells.DarkCommand.Messages.End, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.DeathKnight.Spells.DarkCommand.Raid == true then
							RSA_Print_Raid(string.gsub(RSA.db.profile.DeathKnight.Spells.DarkCommand.Messages.End, ".%a+.", RSA_String_Replace))
						end
					end

				end
			end -- DARK COMMAND
			if spellID == 49560 or spellID == 49576 then -- DEATH GRIP
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				if missType == "MISS" then
					missinfo = "Missed"
				elseif missType ~= "MISS" then
					missinfo = "Resisted"
				end
				RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest, ["[MISSTYPE]"] = missinfo,}
				if RSA.db.profile.DeathKnight.Spells.DeathGrip.Messages.End ~= "" then
					if RSA.db.profile.DeathKnight.Spells.DeathGrip.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							RSA_Print_Self_RW(string.gsub(RSA.db.profile.DeathKnight.Spells.DeathGrip.Messages.End, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							RSA_Print_Self(string.gsub(RSA.db.profile.DeathKnight.Spells.DeathGrip.Messages.End, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.DeathKnight.Spells.DeathGrip.Whisper == true then
						RSA_Print_Whisper(string.gsub(RSA.db.profile.DeathKnight.Spells.DeathGrip.Messages.End, ".%a+.", RSA_String_Replace), dest)
					end
					if RSA.db.profile.DeathKnight.Spells.DeathGrip.CustomChannel.Enabled == true then
						RSA_Print_Channel(string.gsub(RSA.db.profile.DeathKnight.Spells.DeathGrip.Messages.End, ".%a+.", RSA_String_Replace), RSA.db.profile.DeathKnight.Spells.DeathGrip.CustomChannel.Channel)
					end
					if RSA.db.profile.DeathKnight.Spells.DeathGrip.Smart.Say == true then
						RSA_Print_Say(string.gsub(RSA.db.profile.DeathKnight.Spells.DeathGrip.Messages.End, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.DeathKnight.Spells.DeathGrip.Smart.RaidParty == true then
							RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.DeathKnight.Spells.DeathGrip.Messages.End, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.DeathKnight.Spells.DeathGrip.Party == true then
							RSA_Print_Party(string.gsub(RSA.db.profile.DeathKnight.Spells.DeathGrip.Messages.End, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.DeathKnight.Spells.DeathGrip.Raid == true then
							RSA_Print_Raid(string.gsub(RSA.db.profile.DeathKnight.Spells.DeathGrip.Messages.End, ".%a+.", RSA_String_Replace))
						end
					end

				end
			end -- DEATH GRIP				
			if spellID == 47476 then -- STRANGULATE
				if missType == "MISS" then
					missinfo = "Missed"
				elseif missType ~= "MISS" then
					missinfo = "Resisted"
				end
				RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest, ["[MISSTYPE]"] = missinfo,}
				if RSA.db.profile.DeathKnight.Spells.Strangulate.Messages.End ~= "" then
					if RSA.db.profile.DeathKnight.Spells.Strangulate.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							RSA_Print_Self_RW(string.gsub(RSA.db.profile.DeathKnight.Spells.Strangulate.Messages.End, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							RSA_Print_Self(string.gsub(RSA.db.profile.DeathKnight.Spells.Strangulate.Messages.End, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.DeathKnight.Spells.Strangulate.Whisper == true then
						RSA_Print_Whisper(string.gsub(RSA.db.profile.DeathKnight.Spells.Strangulate.Messages.End, ".%a+.", RSA_String_Replace), dest)
					end
					if RSA.db.profile.DeathKnight.Spells.Strangulate.CustomChannel.Enabled == true then
						RSA_Print_Channel(string.gsub(RSA.db.profile.DeathKnight.Spells.Strangulate.Messages.End, ".%a+.", RSA_String_Replace), RSA.db.profile.DeathKnight.Spells.Strangulate.CustomChannel.Channel)
					end
					if RSA.db.profile.DeathKnight.Spells.Strangulate.Smart.Say == true then
						RSA_Print_Say(string.gsub(RSA.db.profile.DeathKnight.Spells.Strangulate.Messages.End, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.DeathKnight.Spells.Strangulate.Smart.RaidParty == true then
							RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.DeathKnight.Spells.Strangulate.Messages.End, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.DeathKnight.Spells.Strangulate.Party == true then
							RSA_Print_Party(string.gsub(RSA.db.profile.DeathKnight.Spells.Strangulate.Messages.End, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.DeathKnight.Spells.Strangulate.Raid == true then
							RSA_Print_Raid(string.gsub(RSA.db.profile.DeathKnight.Spells.Strangulate.Messages.End, ".%a+.", RSA_String_Replace))
						end
					end
				end
			end -- STRANGULATE
			if spellID == 47528 then -- MIND FREEZE
				if missType == "MISS" then
					missinfo = "Missed"
				elseif missType ~= "MISS" then
					missinfo = "Resisted"
				end
				RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest, ["[MISSTYPE]"] = missinfo,}
				if RSA.db.profile.DeathKnight.Spells.MindFreeze.Messages.End ~= "" then
					if RSA.db.profile.DeathKnight.Spells.MindFreeze.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							RSA_Print_Self_RW(string.gsub(RSA.db.profile.DeathKnight.Spells.MindFreeze.Messages.End, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							RSA_Print_Self(string.gsub(RSA.db.profile.DeathKnight.Spells.MindFreeze.Messages.End, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.DeathKnight.Spells.MindFreeze.Whisper == true then
						RSA_Print_Whisper(string.gsub(RSA.db.profile.DeathKnight.Spells.MindFreeze.Messages.End, ".%a+.", RSA_String_Replace), dest)
					end
					if RSA.db.profile.DeathKnight.Spells.MindFreeze.CustomChannel.Enabled == true then
						RSA_Print_Channel(string.gsub(RSA.db.profile.DeathKnight.Spells.MindFreeze.Messages.End, ".%a+.", RSA_String_Replace), RSA.db.profile.DeathKnight.Spells.MindFreeze.CustomChannel.Channel)
					end
					if RSA.db.profile.DeathKnight.Spells.MindFreeze.Smart.Say == true then
						RSA_Print_Say(string.gsub(RSA.db.profile.DeathKnight.Spells.MindFreeze.Messages.End, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.DeathKnight.Spells.MindFreeze.Smart.RaidParty == true then
							RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.DeathKnight.Spells.MindFreeze.Messages.End, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.DeathKnight.Spells.MindFreeze.Party == true then
							RSA_Print_Party(string.gsub(RSA.db.profile.DeathKnight.Spells.MindFreeze.Messages.End, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.DeathKnight.Spells.MindFreeze.Raid == true then
							RSA_Print_Raid(string.gsub(RSA.db.profile.DeathKnight.Spells.MindFreeze.Messages.End, ".%a+.", RSA_String_Replace))
						end
					end
				end
			end -- MIND FREEZE

		end -- IF EVENT IS SPELL_MISSED AND NOT IMMUNE
		
		
		if event == "SPELL_MISSED" and missType == "IMMUNE" then
			if spellID == 56222 then -- DARK COMMAND
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest, ["[MISSTYPE]"] = "Immune",}
				if RSA.db.profile.DeathKnight.Spells.DarkCommand.Messages.Immune ~= "" then
					if RSA.db.profile.DeathKnight.Spells.DarkCommand.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							RSA_Print_Self_RW(string.gsub(RSA.db.profile.DeathKnight.Spells.DarkCommand.Messages.Immune, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							RSA_Print_Self(string.gsub(RSA.db.profile.DeathKnight.Spells.DarkCommand.Messages.Immune, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.DeathKnight.Spells.DarkCommand.Whisper == true then
						RSA_Print_Whisper(string.gsub(RSA.db.profile.DeathKnight.Spells.DarkCommand.Messages.Immune, ".%a+.", RSA_String_Replace), dest)
					end
					if RSA.db.profile.DeathKnight.Spells.DarkCommand.CustomChannel.Enabled == true then
						RSA_Print_Channel(string.gsub(RSA.db.profile.DeathKnight.Spells.DarkCommand.Messages.Immune, ".%a+.", RSA_String_Replace), RSA.db.profile.DeathKnight.Spells.DarkCommand.CustomChannel.Channel)
					end
					if RSA.db.profile.DeathKnight.Spells.DarkCommand.Smart.Say == true then
						RSA_Print_Say(string.gsub(RSA.db.profile.DeathKnight.Spells.DarkCommand.Messages.Immune, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.DeathKnight.Spells.DarkCommand.Smart.RaidParty == true then
							RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.DeathKnight.Spells.DarkCommand.Messages.Immune, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.DeathKnight.Spells.DarkCommand.Party == true then
							RSA_Print_Party(string.gsub(RSA.db.profile.DeathKnight.Spells.DarkCommand.Messages.Immune, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.DeathKnight.Spells.DarkCommand.Raid == true then
							RSA_Print_Raid(string.gsub(RSA.db.profile.DeathKnight.Spells.DarkCommand.Messages.Immune, ".%a+.", RSA_String_Replace))
						end
					end

				end
			end -- DARK COMMAND
			if spellID == 49560 or spellID == 49576 then -- DEATH GRIP
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest, ["[MISSTYPE]"] = "Immune",}
				if RSA.db.profile.DeathKnight.Spells.DeathGrip.Messages.Immune ~= "" then
					if RSA.db.profile.DeathKnight.Spells.DeathGrip.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							RSA_Print_Self_RW(string.gsub(RSA.db.profile.DeathKnight.Spells.DeathGrip.Messages.Immune, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							RSA_Print_Self(string.gsub(RSA.db.profile.DeathKnight.Spells.DeathGrip.Messages.Immune, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.DeathKnight.Spells.DeathGrip.Whisper == true then
						RSA_Print_Whisper(string.gsub(RSA.db.profile.DeathKnight.Spells.DeathGrip.Messages.Immune, ".%a+.", RSA_String_Replace), dest)
					end
					if RSA.db.profile.DeathKnight.Spells.DeathGrip.CustomChannel.Enabled == true then
						RSA_Print_Channel(string.gsub(RSA.db.profile.DeathKnight.Spells.DeathGrip.Messages.Immune, ".%a+.", RSA_String_Replace), RSA.db.profile.DeathKnight.Spells.DeathGrip.CustomChannel.Channel)
					end
					if RSA.db.profile.DeathKnight.Spells.DeathGrip.Smart.Say == true then
						RSA_Print_Say(string.gsub(RSA.db.profile.DeathKnight.Spells.DeathGrip.Messages.Immune, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.DeathKnight.Spells.DeathGrip.Smart.RaidParty == true then
							RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.DeathKnight.Spells.DeathGrip.Messages.Immune, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.DeathKnight.Spells.DeathGrip.Party == true then
							RSA_Print_Party(string.gsub(RSA.db.profile.DeathKnight.Spells.DeathGrip.Messages.Immune, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.DeathKnight.Spells.DeathGrip.Raid == true then
							RSA_Print_Raid(string.gsub(RSA.db.profile.DeathKnight.Spells.DeathGrip.Messages.Immune, ".%a+.", RSA_String_Replace))
						end
					end

				end
			end -- DEATH GRIP					
			if spellID == 47476 then -- STRANGULATE
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest, ["[MISSTYPE]"] = "Immune",}
				if RSA.db.profile.DeathKnight.Spells.Strangulate.Messages.Immune ~= "" then
					if RSA.db.profile.DeathKnight.Spells.Strangulate.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							RSA_Print_Self_RW(string.gsub(RSA.db.profile.DeathKnight.Spells.Strangulate.Messages.Immune, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							RSA_Print_Self(string.gsub(RSA.db.profile.DeathKnight.Spells.Strangulate.Messages.Immune, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.DeathKnight.Spells.Strangulate.Whisper == true then
						RSA_Print_Whisper(string.gsub(RSA.db.profile.DeathKnight.Spells.Strangulate.Messages.Immune, ".%a+.", RSA_String_Replace), dest)
					end
					if RSA.db.profile.DeathKnight.Spells.Strangulate.CustomChannel.Enabled == true then
						RSA_Print_Channel(string.gsub(RSA.db.profile.DeathKnight.Spells.Strangulate.Messages.Immune, ".%a+.", RSA_String_Replace), RSA.db.profile.DeathKnight.Spells.Strangulate.CustomChannel.Channel)
					end
					if RSA.db.profile.DeathKnight.Spells.Strangulate.Smart.Say == true then
						RSA_Print_Say(string.gsub(RSA.db.profile.DeathKnight.Spells.Strangulate.Messages.Immune, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.DeathKnight.Spells.Strangulate.Smart.RaidParty == true then
							RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.DeathKnight.Spells.Strangulate.Messages.Immune, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.DeathKnight.Spells.Strangulate.Party == true then
							RSA_Print_Party(string.gsub(RSA.db.profile.DeathKnight.Spells.Strangulate.Messages.Immune, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.DeathKnight.Spells.Strangulate.Raid == true then
							RSA_Print_Raid(string.gsub(RSA.db.profile.DeathKnight.Spells.Strangulate.Messages.Immune, ".%a+.", RSA_String_Replace))
						end
					end
				end
			end -- STRANGULATE
			if spellID == 47528 then -- MIND FREEZE
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest, ["[MISSTYPE]"] = "Immune",}
				if RSA.db.profile.DeathKnight.Spells.MindFreeze.Messages.Immune ~= "" then
					if RSA.db.profile.DeathKnight.Spells.MindFreeze.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							RSA_Print_Self_RW(string.gsub(RSA.db.profile.DeathKnight.Spells.MindFreeze.Messages.Immune, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							RSA_Print_Self(string.gsub(RSA.db.profile.DeathKnight.Spells.MindFreeze.Messages.Immune, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.DeathKnight.Spells.MindFreeze.Whisper == true then
						RSA_Print_Whisper(string.gsub(RSA.db.profile.DeathKnight.Spells.MindFreeze.Messages.Immune, ".%a+.", RSA_String_Replace), dest)
					end
					if RSA.db.profile.DeathKnight.Spells.MindFreeze.CustomChannel.Enabled == true then
						RSA_Print_Channel(string.gsub(RSA.db.profile.DeathKnight.Spells.MindFreeze.Messages.Immune, ".%a+.", RSA_String_Replace), RSA.db.profile.DeathKnight.Spells.MindFreeze.CustomChannel.Channel)
					end
					if RSA.db.profile.DeathKnight.Spells.MindFreeze.Smart.Say == true then
						RSA_Print_Say(string.gsub(RSA.db.profile.DeathKnight.Spells.MindFreeze.Messages.Immune, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.DeathKnight.Spells.MindFreeze.Smart.RaidParty == true then
							RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.DeathKnight.Spells.MindFreeze.Messages.Immune, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.DeathKnight.Spells.MindFreeze.Party == true then
							RSA_Print_Party(string.gsub(RSA.db.profile.DeathKnight.Spells.MindFreeze.Messages.Immune, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.DeathKnight.Spells.MindFreeze.Raid == true then
							RSA_Print_Raid(string.gsub(RSA.db.profile.DeathKnight.Spells.MindFreeze.Messages.Immune, ".%a+.", RSA_String_Replace))
						end
					end
				end
			end -- MIND FREEZE

		end -- IF EVENT IS SPELL_MISSED AND IS IMMUNE		
	end -- IF SOURCE IS PLAYER		
end -- END ENTIRELY
RSA_CombatLogMonitor:SetScript("OnEvent", DeathKnight_Spells)

end -- END ON ENABLED

function RSA_DeathKnight:OnDisable()

end