------------------------------------------------------
---- Raeli's Spell Announcer Buff Reminder Module ----
------------------------------------------------------
local RSA = LibStub("AceAddon-3.0"):GetAddon("RSA")
local L = LibStub("AceLocale-3.0"):GetLocale("RSA")
local RSA_R = RSA:NewModule("Reminders")

function RSA_R:OnInitialize()
    -- Called when the addon is loaded
    self.db = LibStub("AceDB-3.0"):New("RSADB", defaults) -- Setup Saved Variables
	
	-- Check what class we are and save it. Used to determine what options to show.
	local pClass = select(2, UnitClass("player"))
	self.db.profile.General.Class = pClass	
	
	if RSA.db.profile.Modules.Reminders == true then
	RSA_R:SetEnabledState(true)
	else
	RSA_R:SetEnabledState(false)
	end
end

function RSA_R:OnEnable()
RSA.db.profile.Modules.Reminders_Loaded = true
----------------------------------
---- Spell Reminder Functions ----
----------------------------------
local ReminderTimeElapsed = 0.0
RSA_Reminder = CreateFrame("Frame", "RSA:R")
local function Reminder(self, elapsed)
	if RSA.db.profile.General.Class == "DEATHKNIGHT" then -- Check Class, Set the Spell we're reminding about.
		ReminderSpell = RSA.db.profile.DeathKnight.Reminders.SpellName
	elseif RSA.db.profile.General.Class == "DRUID" then
		ReminderSpell = RSA.db.profile.Druid.Reminders.SpellName
	elseif RSA.db.profile.General.Class == "HUNTER" then
		ReminderSpell = RSA.db.profile.Hunter.Reminders.SpellName
	elseif RSA.db.profile.General.Class == "MAGE" then
		ReminderSpell = RSA.db.profile.Mage.Reminders.SpellName
	elseif RSA.db.profile.General.Class == "PALADIN" then
		ReminderSpell = RSA.db.profile.Paladin.Reminders.SpellName
	elseif RSA.db.profile.General.Class == "PRIEST" then
		ReminderSpell = RSA.db.profile.Priest.Reminders.SpellName
	elseif RSA.db.profile.General.Class == "ROGUE" then
		ReminderSpell = RSA.db.profile.Rogue.Reminders.SpellName
	elseif RSA.db.profile.General.Class == "SHAMAN" then
		ReminderSpell = RSA.db.profile.Shaman.Reminders.SpellName
	elseif RSA.db.profile.General.Class == "WARLOCK" then
		ReminderSpell = RSA.db.profile.Warlock.Reminders.SpellName
	elseif RSA.db.profile.General.Class == "WARRIOR" then
		ReminderSpell = RSA.db.profile.Warrior.Reminders.SpellName
	end
	if ReminderSpell == "" then return end
	if RSA.db.profile.Reminders.DisableInPvP == true and UnitIsPVP("player") then return end
	ReminderTimeElapsed = ReminderTimeElapsed + elapsed
	if ReminderTimeElapsed < RSA.db.profile.Reminders.RemindInterval then return end
	ReminderTimeElapsed = ReminderTimeElapsed - floor(ReminderTimeElapsed)
	local name = UnitBuff("player", ReminderSpell)
	if name == ReminderSpell then
		RSA_Reminder:SetScript("OnUpdate", nil)
	end
	if UnitIsDeadOrGhost("player") == 1 then return end
	if RSA.db.profile.Reminders.EnableInSpec1 == true then
		if GetActiveTalentGroup("player") == 1 then
			if RSA.db.profile.Reminders.RemindChannels.Chat == true then
				RSA_Print_Self(ReminderSpell .. " is Missing!")
			end
			if RSA.db.profile.Reminders.RemindChannels.RaidWarn == true then
				RSA_Print_Self_RW(ReminderSpell .. " is Missing!")
			end
		end
	end
	if RSA.db.profile.Reminders.EnableInSpec2 == true then
		if GetActiveTalentGroup("player") == 2 then
			if RSA.db.profile.Reminders.RemindChannels.Chat == true then
				RSA_Print_Self(ReminderSpell .. " is Missing!")
			end
			if RSA.db.profile.Reminders.RemindChannels.RaidWarn == true then
				RSA_Print_Self_RW(ReminderSpell .. " is Missing!")
			end
		end
	end
end

RSA_Monitor = CreateFrame("Frame", "RSA:M")
local MonitorTimeElapsed = 0.0
local function Monitor(self, elapsed)
	MonitorTimeElapsed = MonitorTimeElapsed + elapsed
	if MonitorTimeElapsed < RSA.db.profile.Reminders.CheckInterval then return end
	MonitorTimeElapsed = MonitorTimeElapsed - floor(MonitorTimeElapsed)
	if RSA.db.profile.General.Class == "DEATHKNIGHT" then -- Check Class, Set the Spell we're reminding about.
		ReminderSpell = RSA.db.profile.DeathKnight.Reminders.SpellName
	elseif RSA.db.profile.General.Class == "DRUID" then
		ReminderSpell = RSA.db.profile.Druid.Reminders.SpellName
	elseif RSA.db.profile.General.Class == "HUNTER" then
		ReminderSpell = RSA.db.profile.Hunter.Reminders.SpellName
	elseif RSA.db.profile.General.Class == "MAGE" then
		ReminderSpell = RSA.db.profile.Mage.Reminders.SpellName
	elseif RSA.db.profile.General.Class == "PALADIN" then
		ReminderSpell = RSA.db.profile.Paladin.Reminders.SpellName
	elseif RSA.db.profile.General.Class == "PRIEST" then
		ReminderSpell = RSA.db.profile.Priest.Reminders.SpellName
	elseif RSA.db.profile.General.Class == "ROGUE" then
		ReminderSpell = RSA.db.profile.Rogue.Reminders.SpellName
	elseif RSA.db.profile.General.Class == "SHAMAN" then
		ReminderSpell = RSA.db.profile.Shaman.Reminders.SpellName
	elseif RSA.db.profile.General.Class == "WARLOCK" then
		ReminderSpell = RSA.db.profile.Warlock.Reminders.SpellName
	elseif RSA.db.profile.General.Class == "WARRIOR" then
		ReminderSpell = RSA.db.profile.Warrior.Reminders.SpellName
	end
	if ReminderSpell == "" then return end
	local name = UnitBuff("player", ReminderSpell)
	if name ~= ReminderSpell then
		RSA_Reminder:SetScript("OnUpdate", Reminder)
	end
end
RSA_Monitor:SetScript("OnUpdate", Monitor)

end

function RSA_R:OnDisable()
RSA.db.profile.Modules.Reminders_Loaded = false
RSA_Monitor:SetScript("OnUpdate", nil)
RSA_Reminder:SetScript("OnUpdate", nil)
end