------------------------------------------------
---- Raeli's Spell Announcer Warrior Module ----
------------------------------------------------
local RSA = LibStub("AceAddon-3.0"):GetAddon("RSA")
local L = LibStub("AceLocale-3.0"):GetLocale("RSA")
local RSA_Warrior = RSA:NewModule("Warrior")

-----------------------
---- Ace functions ----
-----------------------
function RSA_Warrior:OnInitialize()
	
	if RSA.db.profile.General.Class == "WARRIOR" then
	RSA_Warrior:SetEnabledState(true)
	else
	RSA_Warrior:SetEnabledState(false)
	end
end

function RSA_Warrior:OnEnable()

-----------------------------
---- Combat Log Checking ----
-----------------------------
local pName = UnitName("player")
local petName = UnitName("pet")
local function Warrior_Spells(_, _, _, event, _, source, _, _, dest, _, spellID, spellName, _, missType)
	if source == pName or source == petName then
		if (event == "SPELL_CAST_SUCCESS" and RSA.db.profile.Modules.Reminders_Loaded == true) then -- Reminder Refreshed
			local ReminderSpell = RSA.db.profile.Warrior.Reminders.SpellName
			if spellName == ReminderSpell and (dest == pName or dest == nil) then
				RSA_Reminder:SetScript("OnUpdate", nil)				
				if RSA.db.profile.Reminders.RemindChannels.Chat == true then
					RSA_Print_Self(ReminderSpell .. " Refreshed!")
				end
				if RSA.db.profile.Reminders.RemindChannels.RaidWarn == true then
					RSA_Print_Self_RW(ReminderSpell .. " Refreshed!")
				end
			end			
		end -- BUFF REMINDER



		if event == "SPELL_AURA_APPLIED" then
			if spellID == 355 then -- TAUNT
				RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest,}
				if RSA.db.profile.Warrior.Spells.Taunt.Messages.Start ~= "" then
					if RSA.db.profile.Warrior.Spells.Taunt.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							RSA_Print_Self_RW(string.gsub(RSA.db.profile.Warrior.Spells.Taunt.Messages.Start, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							RSA_Print_Self(string.gsub(RSA.db.profile.Warrior.Spells.Taunt.Messages.Start, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Warrior.Spells.Taunt.Whisper == true then
						RSA_Print_Whisper(string.gsub(RSA.db.profile.Warrior.Spells.Taunt.Messages.Start, ".%a+.", RSA_String_Replace), dest)
					end
					if RSA.db.profile.Warrior.Spells.Taunt.CustomChannel.Enabled == true then
						RSA_Print_Channel(string.gsub(RSA.db.profile.Warrior.Spells.Taunt.Messages.Start, ".%a+.", RSA_String_Replace), RSA.db.profile.Warrior.Spells.Taunt.CustomChannel.Channel)
					end
					if RSA.db.profile.Warrior.Spells.Taunt.Smart.Say == true then
						RSA_Print_Say(string.gsub(RSA.db.profile.Warrior.Spells.Taunt.Messages.Start, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Warrior.Spells.Taunt.Smart.RaidParty == true then
							RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.Warrior.Spells.Taunt.Messages.Start, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Warrior.Spells.Taunt.Party == true then
							RSA_Print_Party(string.gsub(RSA.db.profile.Warrior.Spells.Taunt.Messages.Start, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.Warrior.Spells.Taunt.Raid == true then
							RSA_Print_Raid(string.gsub(RSA.db.profile.Warrior.Spells.Taunt.Messages.Start, ".%a+.", RSA_String_Replace))
						end
					end

				end
			end -- TAUNT			
			if spellID == 676 then -- DISARM
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest,}
				if RSA.db.profile.Warrior.Spells.Disarm.Messages.Start ~= "" then
					if RSA.db.profile.Warrior.Spells.Disarm.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							RSA_Print_Self_RW(string.gsub(RSA.db.profile.Warrior.Spells.Disarm.Messages.Start, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							RSA_Print_Self(string.gsub(RSA.db.profile.Warrior.Spells.Disarm.Messages.Start, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Warrior.Spells.Disarm.Whisper == true then
						RSA_Print_Whisper(string.gsub(RSA.db.profile.Warrior.Spells.Disarm.Messages.Start, ".%a+.", RSA_String_Replace), dest)
					end
					if RSA.db.profile.Warrior.Spells.Disarm.CustomChannel.Enabled == true then
						RSA_Print_Channel(string.gsub(RSA.db.profile.Warrior.Spells.Disarm.Messages.Start, ".%a+.", RSA_String_Replace), RSA.db.profile.Warrior.Spells.Disarm.CustomChannel.Channel)
					end
					if RSA.db.profile.Warrior.Spells.Disarm.Smart.Say == true then
						RSA_Print_Say(string.gsub(RSA.db.profile.Warrior.Spells.Disarm.Messages.Start, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Warrior.Spells.Disarm.Smart.RaidParty == true then
							RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.Warrior.Spells.Disarm.Messages.Start, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Warrior.Spells.Disarm.Party == true then
							RSA_Print_Party(string.gsub(RSA.db.profile.Warrior.Spells.Disarm.Messages.Start, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.Warrior.Spells.Disarm.Raid == true then
							RSA_Print_Raid(string.gsub(RSA.db.profile.Warrior.Spells.Disarm.Messages.Start, ".%a+.", RSA_String_Replace))
						end
					end
				end
			end -- DISARM	
			if spellID == 64382 then -- SHATTERING THROW
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest,}
				if RSA.db.profile.Warrior.Spells.ShatteringThrow.Messages.Start ~= "" then
					if RSA.db.profile.Warrior.Spells.ShatteringThrow.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							RSA_Print_Self_RW(string.gsub(RSA.db.profile.Warrior.Spells.ShatteringThrow.Messages.Start, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							RSA_Print_Self(string.gsub(RSA.db.profile.Warrior.Spells.ShatteringThrow.Messages.Start, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Warrior.Spells.ShatteringThrow.Whisper == true then
						RSA_Print_Whisper(string.gsub(RSA.db.profile.Warrior.Spells.ShatteringThrow.Messages.Start, ".%a+.", RSA_String_Replace), dest)
					end
					if RSA.db.profile.Warrior.Spells.ShatteringThrow.CustomChannel.Enabled == true then
						RSA_Print_Channel(string.gsub(RSA.db.profile.Warrior.Spells.ShatteringThrow.Messages.Start, ".%a+.", RSA_String_Replace), RSA.db.profile.Warrior.Spells.ShatteringThrow.CustomChannel.Channel)
					end
					if RSA.db.profile.Warrior.Spells.ShatteringThrow.Smart.Say == true then
						RSA_Print_Say(string.gsub(RSA.db.profile.Warrior.Spells.ShatteringThrow.Messages.Start, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Warrior.Spells.ShatteringThrow.Smart.RaidParty == true then
							RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.Warrior.Spells.ShatteringThrow.Messages.Start, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Warrior.Spells.ShatteringThrow.Party == true then
							RSA_Print_Party(string.gsub(RSA.db.profile.Warrior.Spells.ShatteringThrow.Messages.Start, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.Warrior.Spells.ShatteringThrow.Raid == true then
							RSA_Print_Raid(string.gsub(RSA.db.profile.Warrior.Spells.ShatteringThrow.Messages.Start, ".%a+.", RSA_String_Replace))
						end
					end
				end
			end -- SHATTERING THROW	

			
		end -- IF EVENT IS SPELL_AURA_APPLIED
		
		
		if event == "SPELL_CAST_SUCCESS" then
			if spellID == 871 then -- SHIELD WALL
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest,}
				if RSA.db.profile.Warrior.Spells.ShieldWall.Messages.Start ~= "" then
					if RSA.db.profile.Warrior.Spells.ShieldWall.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							RSA_Print_Self_RW(string.gsub(RSA.db.profile.Warrior.Spells.ShieldWall.Messages.Start, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							RSA_Print_Self(string.gsub(RSA.db.profile.Warrior.Spells.ShieldWall.Messages.Start, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Warrior.Spells.ShieldWall.Whisper == true then
						RSA_Print_Whisper(string.gsub(RSA.db.profile.Warrior.Spells.ShieldWall.Messages.Start, ".%a+.", RSA_String_Replace), dest)
					end
					if RSA.db.profile.Warrior.Spells.ShieldWall.CustomChannel.Enabled == true then
						RSA_Print_Channel(string.gsub(RSA.db.profile.Warrior.Spells.ShieldWall.Messages.Start, ".%a+.", RSA_String_Replace), RSA.db.profile.Warrior.Spells.ShieldWall.CustomChannel.Channel)
					end
					if RSA.db.profile.Warrior.Spells.ShieldWall.Smart.Say == true then
						RSA_Print_Say(string.gsub(RSA.db.profile.Warrior.Spells.ShieldWall.Messages.Start, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Warrior.Spells.ShieldWall.Smart.RaidParty == true then
							RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.Warrior.Spells.ShieldWall.Messages.Start, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Warrior.Spells.ShieldWall.Party == true then
							RSA_Print_Party(string.gsub(RSA.db.profile.Warrior.Spells.ShieldWall.Messages.Start, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.Warrior.Spells.ShieldWall.Raid == true then
							RSA_Print_Raid(string.gsub(RSA.db.profile.Warrior.Spells.ShieldWall.Messages.Start, ".%a+.", RSA_String_Replace))
						end
					end
				end
			end -- SHIELD WALL
			if spellID == 12975 then -- LAST STAND
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest,}
				if RSA.db.profile.Warrior.Spells.LastStand.Messages.Start ~= "" then
					if RSA.db.profile.Warrior.Spells.LastStand.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							RSA_Print_Self_RW(string.gsub(RSA.db.profile.Warrior.Spells.LastStand.Messages.Start, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							RSA_Print_Self(string.gsub(RSA.db.profile.Warrior.Spells.LastStand.Messages.Start, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Warrior.Spells.LastStand.Whisper == true then
						RSA_Print_Whisper(string.gsub(RSA.db.profile.Warrior.Spells.LastStand.Messages.Start, ".%a+.", RSA_String_Replace), dest)
					end
					if RSA.db.profile.Warrior.Spells.LastStand.CustomChannel.Enabled == true then
						RSA_Print_Channel(string.gsub(RSA.db.profile.Warrior.Spells.LastStand.Messages.Start, ".%a+.", RSA_String_Replace), RSA.db.profile.Warrior.Spells.LastStand.CustomChannel.Channel)
					end
					if RSA.db.profile.Warrior.Spells.LastStand.Smart.Say == true then
						RSA_Print_Say(string.gsub(RSA.db.profile.Warrior.Spells.LastStand.Messages.Start, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Warrior.Spells.LastStand.Smart.RaidParty == true then
							RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.Warrior.Spells.LastStand.Messages.Start, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Warrior.Spells.LastStand.Party == true then
							RSA_Print_Party(string.gsub(RSA.db.profile.Warrior.Spells.LastStand.Messages.Start, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.Warrior.Spells.LastStand.Raid == true then
							RSA_Print_Raid(string.gsub(RSA.db.profile.Warrior.Spells.LastStand.Messages.Start, ".%a+.", RSA_String_Replace))
						end
					end
				end
			end -- LAST STAND
			if spellID == 1161 then -- CHALLENGING SHOUT WITH TIMER FOR ENDING
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest,}
				if RSA.db.profile.Warrior.Spells.ChallengingShout.Messages.Start ~= "" then
					if RSA.db.profile.Warrior.Spells.ChallengingShout.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							RSA_Print_Self_RW(string.gsub(RSA.db.profile.Warrior.Spells.ChallengingShout.Messages.Start, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							RSA_Print_Self(string.gsub(RSA.db.profile.Warrior.Spells.ChallengingShout.Messages.Start, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Warrior.Spells.ChallengingShout.Whisper == true then
						RSA_Print_Whisper(string.gsub(RSA.db.profile.Warrior.Spells.ChallengingShout.Messages.Start, ".%a+.", RSA_String_Replace), dest)
					end
					if RSA.db.profile.Warrior.Spells.ChallengingShout.CustomChannel.Enabled == true then
						RSA_Print_Channel(string.gsub(RSA.db.profile.Warrior.Spells.ChallengingShout.Messages.Start, ".%a+.", RSA_String_Replace), RSA.db.profile.Warrior.Spells.ChallengingShout.CustomChannel.Channel)
					end
					if RSA.db.profile.Warrior.Spells.ChallengingShout.Smart.Say == true then
						RSA_Print_Say(string.gsub(RSA.db.profile.Warrior.Spells.ChallengingShout.Messages.Start, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Warrior.Spells.ChallengingShout.Smart.RaidParty == true then
							RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.Warrior.Spells.ChallengingShout.Messages.Start, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Warrior.Spells.ChallengingShout.Party == true then
							RSA_Print_Party(string.gsub(RSA.db.profile.Warrior.Spells.ChallengingShout.Messages.Start, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.Warrior.Spells.ChallengingShout.Raid == true then
							RSA_Print_Raid(string.gsub(RSA.db.profile.Warrior.Spells.ChallengingShout.Messages.Start, ".%a+.", RSA_String_Replace))
						end
					end
				end
				
				local ReminderTimeElapsed = 0.0 -- Start Challenging Shout Timer for end announcement.
				RSA_Timer = CreateFrame("Frame", "RSA:Timer")
				local function CSTimer(self, elapsed)
					ReminderTimeElapsed = ReminderTimeElapsed + elapsed
					if ReminderTimeElapsed < 6 then return end
					ReminderTimeElapsed = ReminderTimeElapsed - floor(ReminderTimeElapsed)
					if RSA.db.profile.Warrior.Spells.ChallengingShout.Messages.End ~= "" then
						if RSA.db.profile.Warrior.Spells.ChallengingShout.Local == true then
							if RSA.db.profile.General.Local.RaidWarn == true then
								RSA_Print_Self_RW(string.gsub(RSA.db.profile.Warrior.Spells.ChallengingShout.Messages.End, ".%a+.", RSA_String_Replace))
							end
							if RSA.db.profile.General.Local.Chat == true then
								RSA_Print_Self(string.gsub(RSA.db.profile.Warrior.Spells.ChallengingShout.Messages.End, ".%a+.", RSA_String_Replace))
							end
						end
						if RSA.db.profile.Warrior.Spells.ChallengingShout.Whisper == true then
							RSA_Print_Whisper(string.gsub(RSA.db.profile.Warrior.Spells.ChallengingShout.Messages.End, ".%a+.", RSA_String_Replace), dest)
						end
						if RSA.db.profile.Warrior.Spells.ChallengingShout.CustomChannel.Enabled == true then
							RSA_Print_Channel(string.gsub(RSA.db.profile.Warrior.Spells.ChallengingShout.Messages.End, ".%a+.", RSA_String_Replace), RSA.db.profile.Warrior.Spells.ChallengingShout.CustomChannel.Channel)
						end
						if RSA.db.profile.Warrior.Spells.ChallengingShout.Smart.Say == true then
							RSA_Print_Say(string.gsub(RSA.db.profile.Warrior.Spells.ChallengingShout.Messages.End, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.General.Smart.RaidParty == true then
							if RSA.db.profile.Warrior.Spells.ChallengingShout.Smart.RaidParty == true then
								RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.Warrior.Spells.ChallengingShout.Messages.End, ".%a+.", RSA_String_Replace))
							end
						end
						if RSA.db.profile.General.Smart.RaidParty == false then
							if RSA.db.profile.Warrior.Spells.ChallengingShout.Party == true then
								RSA_Print_Party(string.gsub(RSA.db.profile.Warrior.Spells.ChallengingShout.Messages.End, ".%a+.", RSA_String_Replace))
							end
							if RSA.db.profile.Warrior.Spells.ChallengingShout.Raid == true then
								RSA_Print_Raid(string.gsub(RSA.db.profile.Warrior.Spells.ChallengingShout.Messages.End, ".%a+.", RSA_String_Replace))
							end
						end
					end			
					RSA_Timer:SetScript("OnUpdate", nil)
				end						
				RSA_Timer:SetScript("OnUpdate", CSTimer)
				
			end -- CHALLENGING SHOUT WITH TIMER FOR ENDING
			if spellID == 50720 then -- VIGILANCE
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest,}
				if RSA.db.profile.Warrior.Spells.Vigilance.Messages.Start ~= "" then
					if RSA.db.profile.Warrior.Spells.Vigilance.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							RSA_Print_Self_RW(string.gsub(RSA.db.profile.Warrior.Spells.Vigilance.Messages.Start, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							RSA_Print_Self(string.gsub(RSA.db.profile.Warrior.Spells.Vigilance.Messages.Start, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Warrior.Spells.Vigilance.Whisper == true and dest ~= pName then
						RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = "You",}
						RSA_Print_Whisper(string.gsub(RSA.db.profile.Warrior.Spells.Vigilance.Messages.Start, ".%a+.", RSA_String_Replace), dest)
						RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest,}
					end
					if RSA.db.profile.Warrior.Spells.Vigilance.CustomChannel.Enabled == true then
						RSA_Print_Channel(string.gsub(RSA.db.profile.Warrior.Spells.Vigilance.Messages.Start, ".%a+.", RSA_String_Replace), RSA.db.profile.Warrior.Spells.Vigilance.CustomChannel.Channel)
					end
					if RSA.db.profile.Warrior.Spells.Vigilance.Smart.Say == true then
						RSA_Print_Say(string.gsub(RSA.db.profile.Warrior.Spells.Vigilance.Messages.Start, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Warrior.Spells.Vigilance.Smart.RaidParty == true then
							RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.Warrior.Spells.Vigilance.Messages.Start, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Warrior.Spells.Vigilance.Party == true then
							RSA_Print_Party(string.gsub(RSA.db.profile.Warrior.Spells.Vigilance.Messages.Start, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.Warrior.Spells.Vigilance.Raid == true then
							RSA_Print_Raid(string.gsub(RSA.db.profile.Warrior.Spells.Vigilance.Messages.Start, ".%a+.", RSA_String_Replace))
						end
					end
				end
			end -- VIGILANCE
			
		end -- IF EVENT IS SPELL_CAST_SUCCESS
		

		if event == "SPELL_INTERRUPT" then
			if spellID == 6552 then -- PUMMEL
				spellinfo = GetSpellInfo(spellID)
				spelllinkinfo = GetSpellLink(spellID)
				extraspellinfo = GetSpellInfo(missType)
				extraspellinfolink = GetSpellLink(missType)
				RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest, ["[TARCAST]"] = extraspellinfo, ["[TARLINK]"] = extraspellinfolink,}
				if RSA.db.profile.Warrior.Spells.Pummel.Messages.Start ~= "" then
					if RSA.db.profile.Warrior.Spells.Pummel.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							RSA_Print_Self_RW(string.gsub(RSA.db.profile.Warrior.Spells.Pummel.Messages.Start, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							RSA_Print_Self(string.gsub(RSA.db.profile.Warrior.Spells.Pummel.Messages.Start, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Warrior.Spells.Pummel.Whisper == true then
						RSA_Print_Whisper(string.gsub(RSA.db.profile.Warrior.Spells.Pummel.Messages.Start, ".%a+.", RSA_String_Replace), dest)
					end
					if RSA.db.profile.Warrior.Spells.Pummel.CustomChannel.Enabled == true then
						RSA_Print_Channel(string.gsub(RSA.db.profile.Warrior.Spells.Pummel.Messages.Start, ".%a+.", RSA_String_Replace), RSA.db.profile.Warrior.Spells.Pummel.CustomChannel.Channel)
					end
					if RSA.db.profile.Warrior.Spells.Pummel.Smart.Say == true then
						RSA_Print_Say(string.gsub(RSA.db.profile.Warrior.Spells.Pummel.Messages.Start, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Warrior.Spells.Pummel.Smart.RaidParty == true then
							RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.Warrior.Spells.Pummel.Messages.Start, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Warrior.Spells.Pummel.Party == true then
							RSA_Print_Party(string.gsub(RSA.db.profile.Warrior.Spells.Pummel.Messages.Start, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.Warrior.Spells.Pummel.Raid == true then
							RSA_Print_Raid(string.gsub(RSA.db.profile.Warrior.Spells.Pummel.Messages.Start, ".%a+.", RSA_String_Replace))
						end
					end
				end
			end -- PUMMEL
			if spellID == 72 then -- SHIELD BASH
				spellinfo = GetSpellInfo(spellID)
				spelllinkinfo = GetSpellLink(spellID)
				extraspellinfo = GetSpellInfo(missType)
				extraspellinfolink = GetSpellLink(missType)
				RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest, ["[TARCAST]"] = extraspellinfo, ["[TARLINK]"] = extraspellinfolink,}
				if RSA.db.profile.Warrior.Spells.ShieldBash.Messages.Start ~= "" then
					if RSA.db.profile.Warrior.Spells.ShieldBash.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							RSA_Print_Self_RW(string.gsub(RSA.db.profile.Warrior.Spells.ShieldBash.Messages.Start, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							RSA_Print_Self(string.gsub(RSA.db.profile.Warrior.Spells.ShieldBash.Messages.Start, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Warrior.Spells.ShieldBash.Whisper == true then
						RSA_Print_Whisper(string.gsub(RSA.db.profile.Warrior.Spells.ShieldBash.Messages.Start, ".%a+.", RSA_String_Replace), dest)
					end
					if RSA.db.profile.Warrior.Spells.ShieldBash.CustomChannel.Enabled == true then
						RSA_Print_Channel(string.gsub(RSA.db.profile.Warrior.Spells.ShieldBash.Messages.Start, ".%a+.", RSA_String_Replace), RSA.db.profile.Warrior.Spells.ShieldBash.CustomChannel.Channel)
					end
					if RSA.db.profile.Warrior.Spells.ShieldBash.Smart.Say == true then
						RSA_Print_Say(string.gsub(RSA.db.profile.Warrior.Spells.ShieldBash.Messages.Start, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Warrior.Spells.ShieldBash.Smart.RaidParty == true then
							RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.Warrior.Spells.ShieldBash.Messages.Start, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Warrior.Spells.ShieldBash.Party == true then
							RSA_Print_Party(string.gsub(RSA.db.profile.Warrior.Spells.ShieldBash.Messages.Start, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.Warrior.Spells.ShieldBash.Raid == true then
							RSA_Print_Raid(string.gsub(RSA.db.profile.Warrior.Spells.ShieldBash.Messages.Start, ".%a+.", RSA_String_Replace))
						end
					end
				end
			end -- SHIELD BASH			
			
		end -- IF EVENT IS SPELL_INTERRUPT

		
		if event == "SPELL_AURA_REMOVED" then
			if spellID == 64382 then -- SHATTERING THROW
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest,}
				if RSA.db.profile.Warrior.Spells.ShatteringThrow.Messages.End ~= "" then
					if RSA.db.profile.Warrior.Spells.ShatteringThrow.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							RSA_Print_Self_RW(string.gsub(RSA.db.profile.Warrior.Spells.ShatteringThrow.Messages.End, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							RSA_Print_Self(string.gsub(RSA.db.profile.Warrior.Spells.ShatteringThrow.Messages.End, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Warrior.Spells.ShatteringThrow.Whisper == true then
						RSA_Print_Whisper(string.gsub(RSA.db.profile.Warrior.Spells.ShatteringThrow.Messages.End, ".%a+.", RSA_String_Replace), dest)
					end
					if RSA.db.profile.Warrior.Spells.ShatteringThrow.CustomChannel.Enabled == true then
						RSA_Print_Channel(string.gsub(RSA.db.profile.Warrior.Spells.ShatteringThrow.Messages.End, ".%a+.", RSA_String_Replace), RSA.db.profile.Warrior.Spells.ShatteringThrow.CustomChannel.Channel)
					end
					if RSA.db.profile.Warrior.Spells.ShatteringThrow.Smart.Say == true then
						RSA_Print_Say(string.gsub(RSA.db.profile.Warrior.Spells.ShatteringThrow.Messages.End, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Warrior.Spells.ShatteringThrow.Smart.RaidParty == true then
							RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.Warrior.Spells.ShatteringThrow.Messages.End, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Warrior.Spells.ShatteringThrow.Party == true then
							RSA_Print_Party(string.gsub(RSA.db.profile.Warrior.Spells.ShatteringThrow.Messages.End, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.Warrior.Spells.ShatteringThrow.Raid == true then
							RSA_Print_Raid(string.gsub(RSA.db.profile.Warrior.Spells.ShatteringThrow.Messages.End, ".%a+.", RSA_String_Replace))
						end
					end
				end
			end -- SHATTERING THROW			
			if spellID == 50720 then -- VIGILANCE
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest,}
				if RSA.db.profile.Warrior.Spells.Vigilance.Messages.End ~= "" then
					if RSA.db.profile.Warrior.Spells.Vigilance.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							RSA_Print_Self_RW(string.gsub(RSA.db.profile.Warrior.Spells.Vigilance.Messages.End, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							RSA_Print_Self(string.gsub(RSA.db.profile.Warrior.Spells.Vigilance.Messages.End, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Warrior.Spells.Vigilance.Whisper == true and dest ~= pName then
						RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = "You",}
						RSA_Print_Whisper(string.gsub(RSA.db.profile.Warrior.Spells.Vigilance.Messages.End, ".%a+.", RSA_String_Replace), dest)
						RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest,}
					end
					if RSA.db.profile.Warrior.Spells.Vigilance.CustomChannel.Enabled == true then
						RSA_Print_Channel(string.gsub(RSA.db.profile.Warrior.Spells.Vigilance.Messages.End, ".%a+.", RSA_String_Replace), RSA.db.profile.Warrior.Spells.Vigilance.CustomChannel.Channel)
					end
					if RSA.db.profile.Warrior.Spells.Vigilance.Smart.Say == true then
						RSA_Print_Say(string.gsub(RSA.db.profile.Warrior.Spells.Vigilance.Messages.End, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Warrior.Spells.Vigilance.Smart.RaidParty == true then
							RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.Warrior.Spells.Vigilance.Messages.End, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Warrior.Spells.Vigilance.Party == true then
							RSA_Print_Party(string.gsub(RSA.db.profile.Warrior.Spells.Vigilance.Messages.End, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.Warrior.Spells.Vigilance.Raid == true then
							RSA_Print_Raid(string.gsub(RSA.db.profile.Warrior.Spells.Vigilance.Messages.End, ".%a+.", RSA_String_Replace))
						end
					end
				end
			end -- VIGILANCE			
			if spellID == 871 then -- SHIELD WALL
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest,}
				if RSA.db.profile.Warrior.Spells.ShieldWall.Messages.End ~= "" then
					if RSA.db.profile.Warrior.Spells.ShieldWall.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							RSA_Print_Self_RW(string.gsub(RSA.db.profile.Warrior.Spells.ShieldWall.Messages.End, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							RSA_Print_Self(string.gsub(RSA.db.profile.Warrior.Spells.ShieldWall.Messages.End, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Warrior.Spells.ShieldWall.Whisper == true then
						RSA_Print_Whisper(string.gsub(RSA.db.profile.Warrior.Spells.ShieldWall.Messages.End, ".%a+.", RSA_String_Replace), dest)
					end
					if RSA.db.profile.Warrior.Spells.ShieldWall.CustomChannel.Enabled == true then
						RSA_Print_Channel(string.gsub(RSA.db.profile.Warrior.Spells.ShieldWall.Messages.End, ".%a+.", RSA_String_Replace), RSA.db.profile.Warrior.Spells.ShieldWall.CustomChannel.Channel)
					end
					if RSA.db.profile.Warrior.Spells.ShieldWall.Smart.Say == true then
						RSA_Print_Say(string.gsub(RSA.db.profile.Warrior.Spells.ShieldWall.Messages.End, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Warrior.Spells.ShieldWall.Smart.RaidParty == true then
							RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.Warrior.Spells.ShieldWall.Messages.End, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Warrior.Spells.ShieldWall.Party == true then
							RSA_Print_Party(string.gsub(RSA.db.profile.Warrior.Spells.ShieldWall.Messages.End, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.Warrior.Spells.ShieldWall.Raid == true then
							RSA_Print_Raid(string.gsub(RSA.db.profile.Warrior.Spells.ShieldWall.Messages.End, ".%a+.", RSA_String_Replace))
						end
					end
				end
			end -- SHIELD WALL
			if spellID == 12976 then -- LAST STAND
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest,}
				if RSA.db.profile.Warrior.Spells.LastStand.Messages.End ~= "" then
					if RSA.db.profile.Warrior.Spells.LastStand.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							RSA_Print_Self_RW(string.gsub(RSA.db.profile.Warrior.Spells.LastStand.Messages.End, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							RSA_Print_Self(string.gsub(RSA.db.profile.Warrior.Spells.LastStand.Messages.End, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Warrior.Spells.LastStand.Whisper == true then
						RSA_Print_Whisper(string.gsub(RSA.db.profile.Warrior.Spells.LastStand.Messages.End, ".%a+.", RSA_String_Replace), dest)
					end
					if RSA.db.profile.Warrior.Spells.LastStand.CustomChannel.Enabled == true then
						RSA_Print_Channel(string.gsub(RSA.db.profile.Warrior.Spells.LastStand.Messages.End, ".%a+.", RSA_String_Replace), RSA.db.profile.Warrior.Spells.LastStand.CustomChannel.Channel)
					end
					if RSA.db.profile.Warrior.Spells.LastStand.Smart.Say == true then
						RSA_Print_Say(string.gsub(RSA.db.profile.Warrior.Spells.LastStand.Messages.End, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Warrior.Spells.LastStand.Smart.RaidParty == true then
							RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.Warrior.Spells.LastStand.Messages.End, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Warrior.Spells.LastStand.Party == true then
							RSA_Print_Party(string.gsub(RSA.db.profile.Warrior.Spells.LastStand.Messages.End, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.Warrior.Spells.LastStand.Raid == true then
							RSA_Print_Raid(string.gsub(RSA.db.profile.Warrior.Spells.LastStand.Messages.End, ".%a+.", RSA_String_Replace))
						end
					end
				end
			end -- LAST STAND
			if spellID == 676 then -- DISARM
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest,}
				if RSA.db.profile.Warrior.Spells.Disarm.Messages.End ~= "" then
					if RSA.db.profile.Warrior.Spells.Disarm.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							RSA_Print_Self_RW(string.gsub(RSA.db.profile.Warrior.Spells.Disarm.Messages.End, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							RSA_Print_Self(string.gsub(RSA.db.profile.Warrior.Spells.Disarm.Messages.End, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Warrior.Spells.Disarm.Whisper == true then
						RSA_Print_Whisper(string.gsub(RSA.db.profile.Warrior.Spells.Disarm.Messages.End, ".%a+.", RSA_String_Replace), dest)
					end
					if RSA.db.profile.Warrior.Spells.Disarm.CustomChannel.Enabled == true then
						RSA_Print_Channel(string.gsub(RSA.db.profile.Warrior.Spells.Disarm.Messages.End, ".%a+.", RSA_String_Replace), RSA.db.profile.Warrior.Spells.Disarm.CustomChannel.Channel)
					end
					if RSA.db.profile.Warrior.Spells.Disarm.Smart.Say == true then
						RSA_Print_Say(string.gsub(RSA.db.profile.Warrior.Spells.Disarm.Messages.End, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Warrior.Spells.Disarm.Smart.RaidParty == true then
							RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.Warrior.Spells.Disarm.Messages.End, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Warrior.Spells.Disarm.Party == true then
							RSA_Print_Party(string.gsub(RSA.db.profile.Warrior.Spells.Disarm.Messages.End, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.Warrior.Spells.Disarm.Raid == true then
							RSA_Print_Raid(string.gsub(RSA.db.profile.Warrior.Spells.Disarm.Messages.End, ".%a+.", RSA_String_Replace))
						end
					end
				end
			end -- DISARM	
			
		end -- IF EVENT IS SPELL_AURA_REMOVED
				
		
		if event == "SPELL_MISSED" and missType ~= "IMMUNE" then
			if spellID == 355 then -- TAUNT
				RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest,}
				if RSA.db.profile.Warrior.Spells.Taunt.Messages.End ~= "" then
					if RSA.db.profile.Warrior.Spells.Taunt.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							RSA_Print_Self_RW(string.gsub(RSA.db.profile.Warrior.Spells.Taunt.Messages.End, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							RSA_Print_Self(string.gsub(RSA.db.profile.Warrior.Spells.Taunt.Messages.End, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Warrior.Spells.Taunt.Whisper == true then
						RSA_Print_Whisper(string.gsub(RSA.db.profile.Warrior.Spells.Taunt.Messages.End, ".%a+.", RSA_String_Replace), dest)
					end
					if RSA.db.profile.Warrior.Spells.Taunt.CustomChannel.Enabled == true then
						RSA_Print_Channel(string.gsub(RSA.db.profile.Warrior.Spells.Taunt.Messages.End, ".%a+.", RSA_String_Replace), RSA.db.profile.Warrior.Spells.Taunt.CustomChannel.Channel)
					end
					if RSA.db.profile.Warrior.Spells.Taunt.Smart.Say == true then
						RSA_Print_Say(string.gsub(RSA.db.profile.Warrior.Spells.Taunt.Messages.End, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Warrior.Spells.Taunt.Smart.RaidParty == true then
							RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.Warrior.Spells.Taunt.Messages.End, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Warrior.Spells.Taunt.Party == true then
							RSA_Print_Party(string.gsub(RSA.db.profile.Warrior.Spells.Taunt.Messages.End, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.Warrior.Spells.Taunt.Raid == true then
							RSA_Print_Raid(string.gsub(RSA.db.profile.Warrior.Spells.Taunt.Messages.End, ".%a+.", RSA_String_Replace))
						end
					end

				end
			end -- TAUNT	
			if spellID == 6552 then -- PUMMEL
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				if missType == "MISS" then
					missinfo = "Missed"
				elseif missType ~= "MISS" then
					missinfo = "Resisted"
				end
				RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest, ["[MISSTYPE]"] = missinfo,}
				if RSA.db.profile.Warrior.Spells.Pummel.Messages.End ~= "" then
					if RSA.db.profile.Warrior.Spells.Pummel.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							RSA_Print_Self_RW(string.gsub(RSA.db.profile.Warrior.Spells.Pummel.Messages.End, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							RSA_Print_Self(string.gsub(RSA.db.profile.Warrior.Spells.Pummel.Messages.End, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Warrior.Spells.Pummel.Whisper == true then
						RSA_Print_Whisper(string.gsub(RSA.db.profile.Warrior.Spells.Pummel.Messages.End, ".%a+.", RSA_String_Replace), dest)
					end
					if RSA.db.profile.Warrior.Spells.Pummel.CustomChannel.Enabled == true then
						RSA_Print_Channel(string.gsub(RSA.db.profile.Warrior.Spells.Pummel.Messages.End, ".%a+.", RSA_String_Replace), RSA.db.profile.Warrior.Spells.Pummel.CustomChannel.Channel)
					end
					if RSA.db.profile.Warrior.Spells.Pummel.Smart.Say == true then
						RSA_Print_Say(string.gsub(RSA.db.profile.Warrior.Spells.Pummel.Messages.End, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Warrior.Spells.Pummel.Smart.RaidParty == true then
							RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.Warrior.Spells.Pummel.Messages.End, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Warrior.Spells.Pummel.Party == true then
							RSA_Print_Party(string.gsub(RSA.db.profile.Warrior.Spells.Pummel.Messages.End, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.Warrior.Spells.Pummel.Raid == true then
							RSA_Print_Raid(string.gsub(RSA.db.profile.Warrior.Spells.Pummel.Messages.End, ".%a+.", RSA_String_Replace))
						end
					end
				end
			end -- PUMMEL
			if spellID == 72 then -- SHIELD BASH
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				if missType == "MISS" then
					missinfo = "Missed"
				elseif missType ~= "MISS" then
					missinfo = "Resisted"
				end
				RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest, ["[MISSTYPE]"] = missinfo,}
				if RSA.db.profile.Warrior.Spells.ShieldBash.Messages.End ~= "" then
					if RSA.db.profile.Warrior.Spells.ShieldBash.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							RSA_Print_Self_RW(string.gsub(RSA.db.profile.Warrior.Spells.ShieldBash.Messages.End, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							RSA_Print_Self(string.gsub(RSA.db.profile.Warrior.Spells.ShieldBash.Messages.End, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Warrior.Spells.ShieldBash.Whisper == true then
						RSA_Print_Whisper(string.gsub(RSA.db.profile.Warrior.Spells.ShieldBash.Messages.End, ".%a+.", RSA_String_Replace), dest)
					end
					if RSA.db.profile.Warrior.Spells.ShieldBash.CustomChannel.Enabled == true then
						RSA_Print_Channel(string.gsub(RSA.db.profile.Warrior.Spells.ShieldBash.Messages.End, ".%a+.", RSA_String_Replace), RSA.db.profile.Warrior.Spells.ShieldBash.CustomChannel.Channel)
					end
					if RSA.db.profile.Warrior.Spells.ShieldBash.Smart.Say == true then
						RSA_Print_Say(string.gsub(RSA.db.profile.Warrior.Spells.ShieldBash.Messages.End, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Warrior.Spells.ShieldBash.Smart.RaidParty == true then
							RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.Warrior.Spells.ShieldBash.Messages.End, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Warrior.Spells.ShieldBash.Party == true then
							RSA_Print_Party(string.gsub(RSA.db.profile.Warrior.Spells.ShieldBash.Messages.End, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.Warrior.Spells.ShieldBash.Raid == true then
							RSA_Print_Raid(string.gsub(RSA.db.profile.Warrior.Spells.ShieldBash.Messages.End, ".%a+.", RSA_String_Replace))
						end
					end
				end
			end -- SHIELD BASH			
			
		end -- IF EVENT IS SPELL_MISSED AND NOT IMMUNE
		
		
		if event == "SPELL_MISSED" and missType == "IMMUNE" then
			if spellID == 355 then -- TAUNT
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest, ["[MISSTYPE]"] = "Immune",}
				if RSA.db.profile.Warrior.Spells.Taunt.Messages.Immune ~= "" then
					if RSA.db.profile.Warrior.Spells.Taunt.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							RSA_Print_Self_RW(string.gsub(RSA.db.profile.Warrior.Spells.Taunt.Messages.Immune, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							RSA_Print_Self(string.gsub(RSA.db.profile.Warrior.Spells.Taunt.Messages.Immune, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Warrior.Spells.Taunt.Whisper == true then
						RSA_Print_Whisper(string.gsub(RSA.db.profile.Warrior.Spells.Taunt.Messages.Immune, ".%a+.", RSA_String_Replace), dest)
					end
					if RSA.db.profile.Warrior.Spells.Taunt.CustomChannel.Enabled == true then
						RSA_Print_Channel(string.gsub(RSA.db.profile.Warrior.Spells.Taunt.Messages.Immune, ".%a+.", RSA_String_Replace), RSA.db.profile.Warrior.Spells.Taunt.CustomChannel.Channel)
					end
					if RSA.db.profile.Warrior.Spells.Taunt.Smart.Say == true then
						RSA_Print_Say(string.gsub(RSA.db.profile.Warrior.Spells.Taunt.Messages.Immune, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Warrior.Spells.Taunt.Smart.RaidParty == true then
							RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.Warrior.Spells.Taunt.Messages.Immune, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Warrior.Spells.Taunt.Party == true then
							RSA_Print_Party(string.gsub(RSA.db.profile.Warrior.Spells.Taunt.Messages.Immune, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.Warrior.Spells.Taunt.Raid == true then
							RSA_Print_Raid(string.gsub(RSA.db.profile.Warrior.Spells.Taunt.Messages.Immune, ".%a+.", RSA_String_Replace))
						end
					end

				end
			end -- TAUNT	
			if spellID == 6552 then -- PUMMEL
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest, ["[MISSTYPE]"] = "Immune",}
				if RSA.db.profile.Warrior.Spells.Pummel.Messages.Immune ~= "" then
					if RSA.db.profile.Warrior.Spells.Pummel.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							RSA_Print_Self_RW(string.gsub(RSA.db.profile.Warrior.Spells.Pummel.Messages.Immune, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							RSA_Print_Self(string.gsub(RSA.db.profile.Warrior.Spells.Pummel.Messages.Immune, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Warrior.Spells.Pummel.Whisper == true then
						RSA_Print_Whisper(string.gsub(RSA.db.profile.Warrior.Spells.Pummel.Messages.Immune, ".%a+.", RSA_String_Replace), dest)
					end
					if RSA.db.profile.Warrior.Spells.Pummel.CustomChannel.Enabled == true then
						RSA_Print_Channel(string.gsub(RSA.db.profile.Warrior.Spells.Pummel.Messages.Immune, ".%a+.", RSA_String_Replace), RSA.db.profile.Warrior.Spells.Pummel.CustomChannel.Channel)
					end
					if RSA.db.profile.Warrior.Spells.Pummel.Smart.Say == true then
						RSA_Print_Say(string.gsub(RSA.db.profile.Warrior.Spells.Pummel.Messages.Immune, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Warrior.Spells.Pummel.Smart.RaidParty == true then
							RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.Warrior.Spells.Pummel.Messages.Immune, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Warrior.Spells.Pummel.Party == true then
							RSA_Print_Party(string.gsub(RSA.db.profile.Warrior.Spells.Pummel.Messages.Immune, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.Warrior.Spells.Pummel.Raid == true then
							RSA_Print_Raid(string.gsub(RSA.db.profile.Warrior.Spells.Pummel.Messages.Immune, ".%a+.", RSA_String_Replace))
						end
					end
				end
			end -- PUMMEL
			if spellID == 72 then -- SHIELD BASH
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["[SPELL]"] = spellinfo, ["[LINK]"] = spelllinkinfo, ["[TARGET]"] = dest, ["[MISSTYPE]"] = "Immune",}
				if RSA.db.profile.Warrior.Spells.ShieldBash.Messages.Immune ~= "" then
					if RSA.db.profile.Warrior.Spells.ShieldBash.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							RSA_Print_Self_RW(string.gsub(RSA.db.profile.Warrior.Spells.ShieldBash.Messages.Immune, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							RSA_Print_Self(string.gsub(RSA.db.profile.Warrior.Spells.ShieldBash.Messages.Immune, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Warrior.Spells.ShieldBash.Whisper == true then
						RSA_Print_Whisper(string.gsub(RSA.db.profile.Warrior.Spells.ShieldBash.Messages.Immune, ".%a+.", RSA_String_Replace), dest)
					end
					if RSA.db.profile.Warrior.Spells.ShieldBash.CustomChannel.Enabled == true then
						RSA_Print_Channel(string.gsub(RSA.db.profile.Warrior.Spells.ShieldBash.Messages.Immune, ".%a+.", RSA_String_Replace), RSA.db.profile.Warrior.Spells.ShieldBash.CustomChannel.Channel)
					end
					if RSA.db.profile.Warrior.Spells.ShieldBash.Smart.Say == true then
						RSA_Print_Say(string.gsub(RSA.db.profile.Warrior.Spells.ShieldBash.Messages.Immune, ".%a+.", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Warrior.Spells.ShieldBash.Smart.RaidParty == true then
							RSA_Print_Smart_RaidParty(string.gsub(RSA.db.profile.Warrior.Spells.ShieldBash.Messages.Immune, ".%a+.", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Warrior.Spells.ShieldBash.Party == true then
							RSA_Print_Party(string.gsub(RSA.db.profile.Warrior.Spells.ShieldBash.Messages.Immune, ".%a+.", RSA_String_Replace))
						end
						if RSA.db.profile.Warrior.Spells.ShieldBash.Raid == true then
							RSA_Print_Raid(string.gsub(RSA.db.profile.Warrior.Spells.ShieldBash.Messages.Immune, ".%a+.", RSA_String_Replace))
						end
					end
				end
			end -- SHIELD BASH			
			
		end -- IF EVENT IS SPELL_MISSED AND IS IMMUNE	
		
		
		
	end -- IF SOURCE IS PLAYER		
end -- END ENTIRELY
RSA_CombatLogMonitor:SetScript("OnEvent", Warrior_Spells)

end -- END ON ENABLED

function RSA_Warrior:OnDisable()

end